#!/usr/bin/perl

print "Content-type: text/plain\n\n";
print "INFOSYS\n";

$ENV{QUERY_STRING}  =~ /([sl])=([,\w]+)/;
if( $1 eq "l" ) {
    $long_mode = 1;
}
$query = $2;
if( $query =~ /ap/ ) { $show_ap = 1; }
if( $query =~ /at/ ) { $show_atech = 1; }
if( $query =~ /ao/ ) { $show_apol = 1; }
if( $query =~ /rn/ ) { $show_rnews = 1; }
if( $query =~ /rb/ ) { $show_rbus = 1; }
if( $query =~ /rt/ ) { $show_rtech = 1; }
if( $query =~ /rp/ ) { $show_rpol = 1; }
if( $query =~ /sd/ ) { $show_slash = 1; }
if( $query =~ /fm/ ) { $show_meat = 1; }
if( $query =~ /tr/ ) { $show_reg = 1; }
if( $query =~ /as/ ) { $all_stocks = 1; }
if( $query =~ /pg/ ) { $show_pigs = 1; }
if( $query =~ /sm/ ) { $show_sarah = 1; }

if( $all_stocks ) {
	open QUOTES, "data/stocks.csv";
	print "Stock Quotes:";
	while( <QUOTES> ) {
		/([\^\w]+)\",([\d.]+),([\+\-\d.]+)/;
		$symb = $1;
		$val = $2;
		$chg = $3;
		if( $chg =~ /([\+\-])([\d\.]+)/ ) {
			$chg = $1 . $2;
		}
		else{
			$chg = "NCHG";
		}
		print "  $symb $val ($chg)";
	}
        print "\n";
}

if( $ENV{QUERY_STRING} =~ /st=([\w\d\^\+"%5E"%]+)/ ) {
    $list = $1;
    $list =~ s/%5E/\\\^/g;
    print "Stock Quotes:";
    while( $list =~ m/([\w\d\^]+)/g ) {
	$sym = $1;
	$found = 0;
      locate:
	open QUOTES, "data/stocks.csv";
	while( <QUOTES> ) {
	    /([\^\w]+)\",([\d.]+),([\+\-\d.]+)/;
	    $symb = $1;
	    $val = $2;
	    $chg = $3;
	    if( $sym eq $symb) {
		if( $chg =~ /([\+\-]*)([\d\.]+)/ ) {
               		$chg = $1 . $2;
		}
		else {
			$chg = "NCHG";
		}
		print "  $symb $val ($chg)";
		$found = 1;
		last;
	    }
	}
	if( !$found ) {
	    print " $sym (not available)";
	}
    }
    print "|http://finance.yahoo.com\n";
}

if( $show_ap ) {
    parse_yahoo( "data/ap.html", "AP News: ", "http://dailynews.yahoo.com/headlines/top_stories/ap/index.html" );
} 

if( $show_atech ) {
    parse_yahoo( "data/aptech.html", "AP Tech:  ", "http://dailynews.yahoo.com/headlines/technology/ap/index.html" );
}
if( $show_apol ) {
    parse_yahoo( "data/appol.html", "AP Politics:  ", "http://dailynews.yahoo.com/headlines/politics/ap/index.html" );
}

if( $show_rnews ) {
    parse_yahoo( "data/rnews.html", "Reuters Headlines: ", "http://dailynews.yahoo.com/headlines/ts/index.html" );
}

if( $show_rbus ) {
    parse_yahoo( "data/rbus.html", "Reuters Business: ", "http://dailynews.yahoo.com/headlines/bs/", "  \$\$  " );
}

if( $show_rtech ) {
    parse_yahoo( "data/rtech.html", "Reuters Technology: ", "http://dailynews.yahoo.com/headlines/tc/" );
}

if( $show_rpol ) {
    parse_yahoo( "data/rpol.html", "Reuters Politics: ", "http://dailynews.yahoo.com/headlines/pl/" );
}

if( $show_slash ) {
	if( $long_mode ) {
		print "Slashdot:|http://slashdot.org\n";
	} else {
		$sep = "Slashdot:  ";
	}
   open NEWS, "data/slashdot.xml";
	@headlines = <NEWS>;
	foreach $line (@headlines) {
		if($line =~ /<title>.*<\/title>/) {
			$line =~ s/.*<title>//g;
			$line =~ s/<\/title>.*//g;
			$head=$line;
			chop $head;
		} else {
			if ($line =~ /<link>.*<\/link>/) {
				$line =~ s/.*<link>//g;
				$line =~ s/<\/link>.*//g;
				chop $line;
				if( $long_mode ) {
		   	 print "$head|$line\n";
				}
				else {
		   		print "$sep$head";
		  			$sep = " /. ";
				}
			}
		}	
	}
	close NEWS;
   if( !$long_mode ) {
		print "|http://slashdot.org\n";
   }
} # Slashdot

if( $show_sarah) {
    print "sarah is a whore\n";
}

if( $show_reg ) {
   open NEWS, "data/thereg.rdf";
        @headlines = <NEWS>;
        foreach $line (@headlines) {
		if($line =~ /<title>.*<\/title>/) {
                        $line =~ s/.*<title>//g;
                        $line =~ s/<\/title>.*//g;
                        $head=$line;
                        chop $head;
                } else {
                        if ($line =~ /<link>.*<\/link>/) {
                                $line =~ s/.*<link>//g;
                                $line =~ s/<\/link>.*//g;
                                chop $line;
                                if( $long_mode ) {
                         print "$head|$line\n";
                                }
                                else {
                                print "$sep$head";
                                        $sep = " /. ";
                                }
                        }
                }
        }
        close NEWS;
   if( !$long_mode ) {
                print "|http://www.theregister.co.uk\n";
   }
} # the register
if( $show_meat ) {
    if( $long_mode ) {
	print "Freshmeat:|http://www.freshmeat.net\n";
    }
    else {
	$sep = "Freshmeat: ";
    }
    open NEWS, "data/freshmeat.txt";
    while( <NEWS> ) {
	$pkg = $_;
	$date = <NEWS>;
	$url = <NEWS>;
	chop $pkg;
	chop $url;
	if( $long_mode ) {
	    print "$pkg|$url\n";
	}
	else {
	    print "$sep$pkg";
	    $sep = "  (fm)  ";
	}
    }
    if( !$long_mode ) {
	print "|http://www.freshmeat.net\n";
    }
} # Freshmeat

if( $show_pigs ) {
    open NEWS, "data/pigs.txt";
    print "Current Pigs : \n";
    while( !( <NEWS> =~ /ker/) ) {
    }
    while( <NEWS> ) {
	print;
    }
}

open NEWS, "infosys.txt";
# ignore their INFOSYS line.
$line = <NEWS>;
while( <NEWS> ) {
    print;
}
sub parse_yahoo {
    my( $file, $prefix, $url, $separator ) = @_;
    if( !$separator ) {
	$separator = "  --  ";
    }
    open NEWS, $file;
    if( $long_mode ) {
	print "$prefix|$url\n";
    }
    my $sep = $prefix;

    while( <NEWS> ) {
        if( /(http.*?html)\"><b>(.*?)<\/b>/ ) {
	    my $story_url = $1;
	    my $headline = $2;
	    if( $long_mode ) {
		print "$headline|$story_url\n";
	    }
	    else {
		print "$sep$headline";
		$sep = $separator;
	    }
        }
        elsif( /Earlier Stories/ ) {
            last;
        }
    }
    if( !$long_mode ) {
	print "|$url\n";
    }
} # Parse Yahoo







